import 'dart:math';

import 'package:contentsquare_platform_interface/contentsquare_platform_interface.dart';
import 'package:flutter/gestures.dart';
import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';

import 'gesture_listener.dart';


class a72 extends StatelessWidget {
  
  final Widget a33;

  
  final Function(Offset position)? a32;

  
  final Function(Offset position)? a31;

  
  final Function(Offset position, ContentsquareGestureData data)? a30;

  
  final Function(Offset position, ContentsquareGestureData data)? a29;

  
  const a72({
    Key? a227,
    required this.a33,
    this.a32,
    this.a31,
    this.a30,
    this.a29,
  }) : super(key: a227);

  bool _a98(a66 a228) {
    return a228.a57.distance.isFinite && a228.a56.isFinite;
  }

  void _a99(PointerEvent a229) {
    a32?.call(a229.position);
  }

  void _a100(PointerEvent a230) {
    a31?.call(a230.position);
  }

  void _a101(a66 a231) {
    final a145 = _a102(a231.a57);
    if (a145 == null) return;

    if (!_a98(a231)) return;

    final ContentsquareGestureData a146 = ContentsquareGestureData(
        distance: a231.a57.distance.toInt(),
        direction: a145,
        velocity:
            max(a231.a56.dx.abs(), a231.a56.dy.abs()).toInt());

    if (a146.velocity >= kMinFlingVelocity) {
      a29?.call(a231.a58, a146);
    } else {
      a30?.call(a231.a58, a146);
    }
  }

  static ContentsquareGestureDirection? _a102(Offset a232) {
    if (a232.dx == 0 && a232.dy == 0) return null;

    if (a232.dx.abs() <= a232.dy.abs()) {
      /// Vertical Gesture
      /// gestureDirection = CSGestureDirection.down OR CSGestureDirection.up
      return a232.dy > 0
          ? ContentsquareGestureDirection.down
          : ContentsquareGestureDirection.up;
    }

    /// Horizontal Gesture
    /// gestureDirection = CSGestureDirection.right OR CSGestureDirection.left
    return a232.dx > 0
        ? ContentsquareGestureDirection.right
        : ContentsquareGestureDirection.left;
  }

  @override
  Widget build(BuildContext context) {
    return a67(
      a54: _a99,
      a53: _a100,
      a49: _a101,
      a55: a33,
    );
  }
}
