import 'dart:collection';
import 'dart:developer';

import 'package:flutter/rendering.dart';
import 'package:flutter/widgets.dart';

import '../../../modules/screengraph/widgets_binding.dart';
import '../compression.dart';
import '../element_extension.dart';
import '../element_visitor.dart';
import '../painted_render_object_tree.dart';
import '../render_object_extension.dart';
import '../unmodifiable_list_view_extension.dart';


UnmodifiableListView<String> a119(Offset a250) {
  final a179 = _a120(a250);

  final a180 = _a121(
    a252: a179,
    a253: _a76.a123(a255: a250),
  );

  
  if (a180 == null) {
    log(
      'Could not find the element associated with the RenderObject $a179 that was found for the gesture at $a250',
    );
    return UnmodifiableListView([]);
  }

  final a181 = _a122(
    a254: a180,
  );

  
  
  final a182 =
  a181.a118();

  final a183 =
  a182.map(a83).toList();

  return UnmodifiableListView(a183);
}


RenderObject _a120(Offset a251) {
  final a184 = a77.a93!.renderView;

  
  
  final a185 = BoxHitTestResult();
  a184.hitTest(a185, position: a251);

  
  return a185.path
      .firstWhere((element) => element.target is RenderObject)
      .target as RenderObject;
}


_a76? _a121({
  required RenderObject a252,
  required _a76 a253,
}) {
  
  
  
  
  
  
  
  
  
  final a186 = a253.a18.a35
      .a104(a253.a19);
  if (a186 == a73.a27) {
    return null;
  }

  
  
  _a76? a187;
  a253.a18.a7(
    a199: (childElementVisitor) {
      a187 = _a121(
        a252: a252,
        a253: a253.a4(a194: childElementVisitor),
      );

      
      return a187 != null;
    },
  );

  
  if (a187 != null) {
    return a187;
  }

  
  if (a253.a18.a35.a103 == a252) {
    return a253;
  }

  
  return null;
}


UnmodifiableListView<String> _a122({
  required _a76 a254,
}) {
  
  
  final a188 = a254.a18.a35
      .a104(a254.a19);
  if (a188 == a73.a27) {
    return UnmodifiableListView([]);
  }

  
  
  final a189 = <String>[];
  a254.a18.a7(
    a199: (childElementVisitor) {
      
      a189.addAll(
        _a122(
          a254: a254.a4(a194: childElementVisitor),
        ),
      );

      
      return false;
    },
  );

  
  if (a189.isNotEmpty) {
    return UnmodifiableListView(a189);
  }

  
  
  
  
  
  if (a188 == a73.a28) {
    return UnmodifiableListView([a254.a16]);
  }

  return UnmodifiableListView([]);
}


class _a76 {
  
  factory _a76.a123({required Offset a255}) {
    
    
    final a190 = a112().a106!;

    final a191 = a71.a95();

    return _a76._a124(
      a19: a255,
      a18: a191,
      a17: a190,
      a16: a191.a34,
    );
  }

  
  _a76 a4({required a71 a194}) {
    final a192 =
        a194.a35.a103?.a106;

    final a193 = a115(
      a243: a192,
      a242: a17,
    );

    return _a76._a124(
      a19: a19,
      a18: a194,
      
      a17:
      a193 ? a192! : a17,
      a16: a193
          ? a194.a34
          : a16,
    );
  }

  
  final Offset a19;

  
  final a71 a18;

  
  final Rect a17;

  
  final String a16;

  
  _a76._a124({
    required this.a19,
    required this.a18,
    required this.a17,
    required this.a16,
  });
}
