import 'dart:developer';

import 'package:flutter/rendering.dart';


extension a79 on RenderObject {
  
  Rect? get a106 => _a108(a234: true);

  
  Rect? get a107 => _a108(a234: false);

  
  Rect? _a108({required bool a234}) {
    final a150 = this;

    
    
    
    
    
    if (a150 is RenderView) {
      
      
      
      
      return a150.child?._a108(
        a234: a234,
      );
    } else if (a150 is RenderBox) {
      return _a110(
        a150,
        a237: a234,
      );
    } else if (a150 is RenderSliver) {
      return _a111(
        a150,
        a239: a234,
      );
    } else {
      log(
        'The RenderObject of type ${a150.runtimeType} is not supported. Therefore its size cannot be determined.',
      );
      return null;
    }
  }

  
  Rect _a109({
    required bool a235,
  }) {
    if (!a235) {
      return paintBounds;
    }

    
    
    
    final a151 = getTransformTo(null).getTranslation();
    return paintBounds.shift(Offset(a151.x, a151.y));
  }
}


Rect? _a110(
  RenderBox a236, {
  required bool a237,
}) {
  if (!a236.hasSize) {
    return null;
  }

  return a236._a109(
    a235: a237,
  );
}


Rect? _a111(
  RenderSliver a238, {
  required bool a239,
}) {
  if (a238.geometry == null) {
    return null;
  }

  return a238._a109(
    a235: a239,
  );
}
