import 'package:flutter/widgets.dart';
import 'package:flutter_test/flutter_test.dart';

Offset getCenterFromRenderBoxKey({required Key key}) {
  final renderObject =
      find.byKey(key).evaluate().first.renderObject as RenderBox;
  return renderObject.localToGlobal(
    Offset(renderObject.size.width / 2, renderObject.size.height / 2),
  );
}
