import 'package:auto_route/auto_route.dart';
import 'package:flutter/material.dart';

import '../../../routes/app_router.dart';

class CasesRouterWrapper extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      floatingActionButton: FloatingActionButton(
        onPressed: () => AutoRouter.of(context).push(JumpingRoute()),
        backgroundColor: Theme.of(context).scaffoldBackgroundColor,
        child: Icon(Icons.arrow_circle_up, color: Colors.black),
      ),
      body: AutoRouter(),
    );
  }
}
