import 'package:contentsquare_example/src/widgets/app_bar.dart';
import 'package:flutter/material.dart';

import 'recyclable_widgets.dart';

class CustomScrollViewScreen extends StatelessWidget {
  const CustomScrollViewScreen({Key? key}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: appBar(title: 'Custom Scroll View Example'),
      body: _buildRecyclableView(),
    );
  }

  Widget _buildRecyclableView() {
    return CustomScrollView(
      slivers: [
        buildSliverGrid(10),
        buildSliverList(100),
      ],
    );
  }
}
