
import 'package:flutter/material.dart';

import '../../../../widgets/app_bar.dart';
import 'recyclable_widgets.dart';

class SliverGridScreen extends StatelessWidget {
  const SliverGridScreen({Key? key}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: appBar(title: 'Sliver Grid Example'),
      body: _buildRecyclableView(),
    );
  }

  Widget _buildRecyclableView() {
    return CustomScrollView(
      slivers: [
        buildSliverGrid(200)
      ]
    );
  }
}
