import 'package:flutter/material.dart';

import '../../../../widgets/app_bar.dart';
import 'recyclable_widgets.dart';

class SliverListScreen extends StatelessWidget {
  const SliverListScreen({Key? key}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: appBar(title: 'Sliver List Example'),
      body: _buildRecyclableView(),
    );
  }

  Widget _buildRecyclableView() {
    return CustomScrollView(
      slivers: [buildSliverList(200)],
    );
  }
}
