import 'package:background_locator/background_locator.dart';
import 'package:flutter/material.dart';

/// Initilize the backgorund_locator plugin
///
/// We use this plugin in the simple_app to test the compatibility with the
/// background_locator plugin which had a known initilization problem.
class BackgroundLocatorInitializer extends StatefulWidget {
  const BackgroundLocatorInitializer({
    Key? key,
    required this.child,
  }) : super(key: key);

  final Widget child;

  @override
  State<BackgroundLocatorInitializer> createState() =>
      _BackgroundLocatorInitializerState();
}

class _BackgroundLocatorInitializerState
    extends State<BackgroundLocatorInitializer> {
  @override
  void initState() {
    super.initState();
    BackgroundLocator.initialize();
  }

  @override
  Widget build(BuildContext context) => widget.child;
}
