library contentsquare;

import 'package:contentsquare/src/modules/gestures/cs_gesture_detector.dart';
import 'package:contentsquare/src/modules/screengraph/hit_test/get_tvp_at_hit_position.dart';
import 'package:contentsquare_platform_interface/contentsquare_platform_interface.dart';
import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';

import '../contentsquare.dart';

/// ContentsquareRoot widget
///
/// Place it at the root of your app to provide your app with zoning features
class ContentsquareRoot extends StatelessWidget {
  /// ContensquareRoot widget constructor
  const ContentsquareRoot({Key? key, required this.child}) : super(key: key);

  /// Child widget
  final Widget child;

  void _a82({
    required ContentsquareGesture a211,
    required Offset a212,
    ContentsquareGestureData? a213,
  }) {
    final a126 = a119(a212);

    
    
    for (var a127 in a126) {
      Contentsquare().sendTouchEvent(
        type: a211,
        version: version,
        data: TouchEventData(path: a127, gestureData: a213),
      );
    }
  }

  @override
  Widget build(BuildContext context) {
    return a72(
      a32: (position) => _a82(
        a212: position,
        a211: ContentsquareGesture.tap,
      ),
      a31: (position) => _a82(
        a212: position,
        a211: ContentsquareGesture.longPress,
      ),
      a30: (position, data) => _a82(
        a212: position,
        a211: ContentsquareGesture.drag,
        a213: data,
      ),
      a29: (position, data) => _a82(
        a212: position,
        a211: ContentsquareGesture.flick,
        a213: data,
      ),
      a33: child,
    );
  }
}
