import 'dart:collection';
import 'dart:convert';

import 'package:flutter/rendering.dart';
import 'package:flutter/widgets.dart';

import 'compression.dart';
import 'element_tree.dart';
import 'render_object_extension.dart';
import 'widgets_binding.dart';


RenderView a112() {
  return a77.a93!.renderView;
}


Future<String> a113({
  required String a240,
  required double a241,
}) async {
  final a152 = await _a114(
  );

  final a153 = a152.a5(
    a195: a241,
    
    a196: null,
    a197: a240,
  );

  
  
  a153[0]['style']['bmp'] =
      'com_contentsquare_rootViewBitmapPlaceholder';

  return json.encode(a153);
}


Future<a74> _a114() async {
  final a154 = a112();

  final a155 = a86();

  final a156 = await _a116(
    a244: a154,
    a245: a155,
  );

  
  
  return a156!;
}


class a74 {
  
  a74({
    required this.a25,
    required this.a24,
    required this.a23,
    required this.a22,
    required this.a21,
  });

  
  final RenderObject a25;

  
  final Rect a24;

  
  final String a23;

  
  final Widget a22;

  
  final UnmodifiableListView<a74> a21;

  
  String get a1 => '${a22.runtimeType}';

  
  UnmodifiableListView<Map<String, dynamic>> a5({
    required double a195,
    required Rect? a196,
    required String a197,
  }) {
    assert(
      () {
        final a157 = a25 == a112();

        return (a157 && a196 == null) ||
            (!a157 && a196 != null);
      }(),
      'The parent global frame must be null if and only if this is the root node',
    );

    
    
    
    final a158 = a115(
      a243: a24,
      a242: a196,
    );
    if (!a158) {
      return UnmodifiableListView([
        for (final a159 in a21)
          ...a159.a5(
            a195: a195,
            a196: a24,
            a197: a197,
          )
      ]);
    }

    return UnmodifiableListView([
      {
        'id': a1,
        'metadata': {
          'class_name': a1,
          
          
          'fullpath': a197 + a83(a23),
        },

        /// "recordingId" should only be mandatory for session replay
        /// On the iOS SDK, the structure is used for both: snapshoting and session replay features
        /// so it ends up mandatory for the screengraph passed down to the ExternalBridgeInterface.takeSnapshot completion
        /// For this reason, we set temporarily a 'recordingId' value based on the widget's runtimeType.
        /// TODO: This will need to be checked and discussed when implementing session replay related features
        'recordingId': a1,
        'style': {
          'height': a24.height * a195,
          'width': a24.width * a195,
          'x': a24.left * a195,
          'y': a24.top * a195,
          'visibility': true,
        },
        
        'format': 1,
        'children': [
          for (final a160 in a21)
            ...a160.a5(
              a195: a195,
              a196: a24,
              a197: a197,
            ),
        ],
      },
    ]);
  }
}


bool a115({
  required Rect? a242,
  required Rect? a243,
}) {
  return a243 != null && a242 != a243;
}


Future<a74?> _a116({
  required RenderObject a244,
  required a65 a245,
}) async {
  assert(
    a245.a61 == a244,
    '	_getPaintedRenderObjectNode was called with a [ElementNode] in which the '
    'renderObject does not match the given [paintedRenderObject]',
  );

  final a161 = a244.a107;
  final a162 = a244.a106;

  
  
  
  
  
  if (a161 == null || a162 == null) {
    return null;
  }

  final a163 = <a74>[];
  
  
  final a164 = LayerHandle<ContainerLayer>();
  a164.layer = ContainerLayer();

  final a165 = _a75(
    a164.layer!,
    a161,
  );

  
  
  
  a244.paint(a165, Offset.zero);

  
  a164.layer = null;

  
  final a166 = a165.a0;
  for (final a167 in a166) {
    final a168 = _a117(
      a248: a167,
      a249: a245,
    );

    
    
    
    
    
    
    
    
    if (a168 != null) {
      final a169 = await _a116(
        a244: a167,
        a245: a168,
      );

      if (a169 != null) {
        a163.add(a169);
      }
    }
  }

  
  
  
  
  
  a244.markNeedsPaint();

  return a74(
    a25: a244,
    a24: a162,
    a22: a245.a62,
    a23: a245.a60,
    a21: UnmodifiableListView(a163),
  );
}


class _a75 extends PaintingContext {
  _a75(
    ContainerLayer a246,
    Rect a247, {
    this.a20,
  }) : super(a246, a247);

  
  UnmodifiableListView<RenderObject> get a0 =>
      UnmodifiableListView<RenderObject>(_a170);

  
  final List<RenderObject> _a170 = <RenderObject>[];

  /// This is what is called by a [renderObject] to paint a child.
  @override
  void paintChild(RenderObject child, Offset offset) {
    _a170.add(child);
    a20?.call(child);

    
  }

  
  final void Function(RenderObject child)? a20;

  /// Some render object use [_a75.pushLayer] to paint their
  /// children. This calls [createChildContext] to create a new context on which
  /// the render object will paint its child.
  /// Therefore we need to also return an [_a75] which will
  /// report to this [_a75] the children that tried to be
  /// painted.
  @override
  _a75 createChildContext(
    ContainerLayer childLayer,
    Rect bounds,
  ) {
    return _a75(
      childLayer,
      bounds,
      a20: _a170.add,
    );
  }
}


a65? _a117({
  required RenderObject a248,
  required a65 a249,
}) {
  final a171 = a249;

  
  
  final a172 = List.of([a171]);
  while (a172.isNotEmpty) {
    final a173 = a172.removeAt(0);
    if (a173.a61 == a248) {
      return a173;
    }

    a172.addAll(a173.a59);
  }

  return null;
}
